//=============================================================================
//
// file :        Keithley2182A.h
//
// description : Include for the Keithley2182A class.
//
// project :	Keithley2182A Class
//
// $Author: olivierroux $
//
// $Revision: 1.1 $
// $Date: 2013-02-14 14:53:51 $
//
// SVN only:
// $HeadURL: $
//
// CVS only:
// $Source: /users/chaize/newsvn/cvsroot/Instrumentation/Keithley2182A/src/Keithley2182A.h,v $
// $Log: not supported by cvs2svn $
//
// copyleft :    European Synchrotron Radiation Facility
//               BP 220, Grenoble 38043
//               FRANCE
//
//=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================
#ifndef _KEITHLEY2182A_H
#define _KEITHLEY2182A_H

#include <tango.h>
//using namespace Tango;

/**
 * @author	$Author: olivierroux $
 * @version	$Revision: 1.1 $
 */

 //	Add your own constant definitions here.
//-----------------------------------------------
#include <yat4tango/InnerAppender.h>
#include "nanoVoltInterface.h"


namespace Keithley2182A_ns
{

/**
 * Class Description:
 * This class aims to control a Keithley 2182A nanovoltmeter with a Gpib Device
 */

/*
 *	Device States Description:
*  Tango::FAULT :    An error has occured during initialization or measure time
*  Tango::RUNNING :  The nanovoltmeter is acquiring
*  Tango::ALARM :    The nanovoltmeter is in OVERFLOW.
 *                    Try to change the range or use the autorange function
 */


class Keithley2182A: public Tango::Device_4Impl
{
public :
	//	Add your own data members here
	//-----------------------------------------


	//	Here is the Start of the automatic code generation part
	//-------------------------------------------------------------	
/**
 *	@name attributes
 *	Attribute member data.
 */
//@{
		//Tango::DevUShort	*attr_channel_read;
		//Tango::DevDouble	*attr_value_read;
		//Tango::DevString	*attr_range_read;
		//Tango::DevBoolean	*attr_autoRange_read;
//@}

/**
 * @name Device properties
 * Device properties member data.
 */
//@{
/**
 *	This property contains the name of the GPIB device used to control the Nanovoltmeter
 */
	string	gpibDeviceName;
//@}

/**
 *	@name Device properties
 *	Device property member data.
 */
//@{
//@}

/**@name Constructors
 * Miscellaneous constructors */
//@{
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device Name
 */
	Keithley2182A(Tango::DeviceClass *cl,string &s);
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device Name
 */
	Keithley2182A(Tango::DeviceClass *cl,const char *s);
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device name
 *	@param d	Device description.
 */
	Keithley2182A(Tango::DeviceClass *cl,const char *s,const char *d);
//@}

/**@name Destructor
 * Only one destructor is defined for this class */
//@{
/**
 * The object destructor.
 */	
	~Keithley2182A() {delete_device();};
/**
 *	will be called at device destruction or at init command.
 */
	void delete_device();
//@}

	
/**@name Miscellaneous methods */
//@{
/**
 *	Initialize the device
 */
	virtual void init_device();
/**
 *	Always executed method before execution command method.
 */
	virtual void always_executed_hook();

//@}

/**
 * @name Keithley2182A methods prototypes
 */

//@{
/**
 *	Hardware acquisition for attributes.
 */
	virtual void read_attr_hardware(vector<long> &attr_list);
/**
 *	Extract real attribute values for channel acquisition result.
 */
	virtual void read_channel(Tango::Attribute &attr);
/**
 *	Extract real attribute values for value acquisition result.
 */
	virtual void read_value(Tango::Attribute &attr);
/**
 *	Extract real attribute values for range acquisition result.
 */
	virtual void read_range(Tango::Attribute &attr);
/**
 *	Extract real attribute values for autoRange acquisition result.
 */
	virtual void read_autoRange(Tango::Attribute &attr);
/**
 *	Read/Write allowed for channel attribute.
 */
	virtual bool is_channel_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for value attribute.
 */
	virtual bool is_value_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for range attribute.
 */
	virtual bool is_range_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for autoRange attribute.
 */
	virtual bool is_autoRange_allowed(Tango::AttReqType type);
/**
 *	Execution allowed for SelectCH1 command.
 */
	virtual bool is_SelectCH1_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for SelectCH2 command.
 */
	virtual bool is_SelectCH2_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for AutoRangeON command.
 */
	virtual bool is_AutoRangeON_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for AutoRangeOFF command.
 */
	virtual bool is_AutoRangeOFF_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for RangeUP command.
 */
	virtual bool is_RangeUP_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for RangeDOWN command.
 */
	virtual bool is_RangeDOWN_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for GetRange command.
 */
	virtual bool is_GetRange_allowed(const CORBA::Any &any);
/**
 * This command allows to select the channel 1 for the acquisition
 *	@exception DevFailed
 */
	void	select_ch1();
/**
 * This command allows to select the channel 2 for the acquisition
 *	@exception DevFailed
 */
	void	select_ch2();
/**
 * This command sets the autorange for the current channel
 *	@exception DevFailed
 */
	void	auto_range_on();
/**
 * This command unsets the autorange for the current channel
 *	@exception DevFailed
 */
	void	auto_range_off();
/**
 * This command sets the upper range for the current channel
 *	@exception DevFailed
 */
	void	range_up();
/**
 * This command sets the lower range for the current channel
 *	@exception DevFailed
 */
	void	range_down();
/**
 * This command returns the the current range
 *	@return	Range value
 *	@exception DevFailed
 */
	Tango::DevString	get_range();

/**
 *	Read the device properties from database
 */
	 void get_device_property();
//@}

	//	Here is the end of the automatic code generation part
	//-------------------------------------------------------------	



protected :	
	//	Add your own data members here
	//-----------------------------------------
	//- get the upper range
	std::string get_upper_range();

	//- get the lower range
	std::string get_lower_range();

	//- channel number
	unsigned short m_channel;

	//- value
	double m_value;

	//- range 1
	Tango::DevString    m_range_1;

	//- range 2
	Tango::DevString    m_range_2;

	//- autoRange for channel 1
	bool m_autoRange1;

	//- autoRange for channel 2
	bool m_autoRange2;

	//- deviceProxy for gpibDevice
	Tango::DeviceProxy * m_deviceProxy;

	//- interface for the commands
	nanoVoltInterface * m_interface;
};

}	// namespace_ns

#endif	// _KEITHLEY2182A_H
